function newArray (s,b)
	local g = {}
	for i = s,b do
		g[i] = 0
	end
	return g
end

dofile ("sys/lua/Player_Tracker.lua")

TotalPlayers = 0
--MaxPlayers = game("maxplayers")
CurrentMap = map("name")
CurrentTracks = 0		-- do NOT change
TargetPlayerData01 = newArray(1, 32)
TargetPlayerData02 = newArray(1, 32)
TargetPlayerData03 = newArray(1, 32)


function getTracksData ()
	local data = io.open("sys/track.tdf")
	if ( data ~= nil ) then
		for line in io.lines("sys/track.tdf","r") do
			CurrentTracks = tonumber(string.sub(line, 1, string.len(line)))
		end
	else
		error ("Can not find data file!")
	end
end

function storeTracksData ()
	local file = assert(io.open("sys/track.tdf","w"))
	if ( file ~= nil ) then
		file:write( CurrentTracks + 1 )
		file:close()
	end
end

function getCurrentTotalPlayers ()
	local plyr
	for plyr = 1, 32 do
		if ( player(plyr, "exists") ) then
			TotalPlayers = TotalPlayers + 1
		else
			TotalPlayers = TotalPlayers - 1
		end
			return TotalPlayers
	end
end

function beginTrack ()
	print ("\n-----------------------------")
	getTracksData()
	storeTracksData()
	print ("Player Tracker initialized")
	print ("Track: "..CurrentTracks)
	print ("Version: Beta 1.0")
	print ("Created by: VoidEssence")
	print ("-----------------------------\n")
end

beginTrack()

--[[ Custom Settings ]]--
TimeType = os.date()
TrackNamesPrefix = "Track_"..getSaveNumber(CurrentTracks)
-------------------------

function StartTrackPlayersBegin (id)
	if ( player(id, "exists") ) then
		TargetPlayerData01[id] = "CS2D VERSION: "..getGameVersion().." \n \n["..TimeType.."] --- Player Track_"..CurrentTracks.." Started --- \n["..TimeType.."] Target: "..player(id, "name").." | USGN: "..player(id, "usgn").." | IP: "..player(id, "ip").." | Clan: "..getIsInClan(id).." | Port: "..getPort(id).." | Bot/Player: "..getPlayerType(id).." | ID: "..id.." | Map: "..CurrentMap.." | Team: "..getTeam(id).." | Ping: "..player(id, "ping").." |"
	end
end

function StartTrackPlayersUpdate (id)
	if ( player(id, "exists") ) then
		TargetPlayerData03[id] = "\n \n \n --- Lesser info ---\n Health: "..getHealth(id).."/"..getMaxHealth(id).." | Money: "..getMoney(id).."/16000 | Weapon: "..getCurrentPlayerWeapon(id).." | Weapon Type: "..player(id, "weapontype").." | Idle: "..player(id, "idle").." | Tile Posistion: "..player(id, "tilex").."(X) "..player(id, "tiley").."(Y) | Speedmod: "..getSpeed(id).." | Fav Team: "..player(id, "favteam").." |"
	end
end

function StartTrackPlayersEnd (id)
	if ( player(id, "exists") ) then
		TargetPlayerData02[id] = " \n["..TimeType.."] Kills: "..player(id, "score").." | Deaths: "..player(id, "deaths").." | Position: "..player(id, "x").."(X) "..player(id, "y").."(Y) | Teamkills: "..player(id, "teamkills").." | Hostage kills: "..player(id, "hostagekills").." | Team Building Kills: "..player(id, "teambuildingkills").." | Sprayname: "..player(id, "sprayname").." | Ping: "..player(id, "ping").." |"
	end
end

function SavePlayerLog (id)
	if ( player(id, "exists") ) then
		local file = assert(io.open("Data/"..TrackNamesPrefix.."_"..player(id, "name").."_"..os.clock()..".txt","w"))
		file:write(TargetPlayerData01[id].." "..TargetPlayerData02[id].." "..TargetPlayerData03[id])
		file:close()
	end
end

addhook("team","PT_team")
function PT_team (id)
	StartTrackPlayersBegin(id)
	getCurrentTotalPlayers()
end

addhook("spawn","PT_spawn")
function PT_spawn (id)
	StartTrackPlayersBegin(id)
end

addhook("ms100","PT_ms100")
function PT_ms100 ()
	getCurrentTotalPlayers()
end

addhook("leave","PT_leave")
function PT_leave(id)
	StartTrackPlayersUpdate(id)
	StartTrackPlayersEnd(id)
	SavePlayerLog(id)
end

addhook("mapchange","PT_mapchange")
function PT_mapchange ()
	StartTrackPlayersEnd(id)
	SavePlayerLog(id)
end